<?php
set_time_limit(200);
//header('Content-type: text/plain; charset=utf-8');


define('DEV_KEY', 'AIzaSyBHgg6XWZJFZVZeIygIqwiOGVvQZ8cfhaw');
define('commentaire', '#');
define('correspondance', '=');
define('encapsulation', "");

if (isset($_GET['src']) && isset($_GET['dst'])) {
    foreach (glob($_GET['src']."/*.lang") as $filename) {
        trad($_GET['src'], $_GET['dst'], basename($filename));
    }
    print 'DONE' ;
} else {
    $dst  = ['de_DE',
        'nl_NL',
        'fr_BE',
        'fr_CH',
        'it_IT',
        'en_EN',
        'en_UK',
        'en_US',
        'es_ES',
        'ru_RU',
        'pt_PT',
    ];
    $link = "http://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'].'?overwrite=true&src=fr_FR&dst[]='.implode('&dst[]=', $dst);
    print "Usage: <br> <a href='$link'>$link</a>";
}

function trad($src, $dst, $file_lang_name)
{
    if (is_array($dst)) {
        foreach ($dst as $dst1) {
            trad($src, $dst1, $file_lang_name);
        }
        return null;
    }
    if (!is_dir($dst)) { // création du répertoire de sortie
        mkdir($dst);
    }
    $handleSrc = fopen($src.DIRECTORY_SEPARATOR.$file_lang_name, "r");
    $handleDst = fopen($dst.DIRECTORY_SEPARATOR.$file_lang_name, "w");
    if (file_exists($dst.DIRECTORY_SEPARATOR.$file_lang_name) && !(isset($_GET['overwrite']) && $_GET['overwrite'] == 'true')) {
        return null;
    }
    if ($handleSrc && $handleDst) {
        $gt   = new LanguageTranslator();
        //var_dump($gt);
        while (($line = fgets($handleSrc)) !== false) {
            $checkCom = trim($line);
            if ($checkCom[0] == commentaire || strpos($line, correspondance) === FALSE) { // pas besoin de traduire
                $newLine = str_ireplace($src, $dst, $line);
            } else { // on traduit
                list($key, $srcTrad) = explode(correspondance, $line, 2); // on coup la ligne en deux à partir de =
                $srcTrad = trim(trim($srcTrad), encapsulation); //on enlève les espaces et les encapsulations
                try {
                    $dstTrad = $gt->translate($srcTrad, $dst, $src); // on traduit
                } catch (Exception $exc) {
                    //echo 'Exception reçue : ',  $exc->getMessage(), "\n";
                    // traduction impossible
                    $dstTrad = $srcTrad;
                }
                $newLine = $key.correspondance.encapsulation.$dstTrad.encapsulation."\n"; // on réassemble
            }
            //echo $newLine;
            fputs($handleDst, $newLine);
        }
        fclose($handleSrc);
        fclose($handleDst);
    } else {
        echo "error opening the files ".$src.DIRECTORY_SEPARATOR.$file_lang_name." ".$dst.DIRECTORY_SEPARATOR.$file_lang_name;
    }
}

class LanguageTranslator
{
    // this is the API endpoint, as specified by Google
    const ENDPOINT = 'https://www.googleapis.com/language/translate/v2';

    // holder for you API key, specified when an instance is created
    protected $_apiKey;

    // constructor, accepts Google API key as its only argument
    public function __construct()
    {
        $this->_apiKey = DEV_KEY;
    }

    // translate the text/html in $data. Translates to the language
    // in $target. Can optionally specify the source language
    public function translate($data, $target, $source = '')
    {
        // this is the form data to be included with the request
        $values = array(
            'key' => $this->_apiKey,
            'target' => substr($target, 0, 2),
            'q' => $data
        );

        // only include the source data if it's been specified
        if (strlen($source) > 0) {
            $values['source'] = substr($source, 0, 2);
        }

        // turn the form data array into raw format so it can be used with cURL
        $formData = http_build_query($values);

        // create a connection to the API endpoint
        $ch = curl_init(self::ENDPOINT);

        // tell cURL to return the response rather than outputting it
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        // write the form data to the request in the post body
        curl_setopt($ch, CURLOPT_POSTFIELDS, $formData);

        // include the header to make Google treat this post request as a get request
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('X-HTTP-Method-Override: GET'));

        // execute the HTTP request
        $json = curl_exec($ch);
        curl_close($ch);

        // decode the response data
        $data = json_decode($json, true);

//        print_r($values);
//        print_r($data);
        // ensure the returned data is valid
        if (!is_array($data) || !array_key_exists('data', $data)) {
            throw new Exception('Unable to find data key');
        }

        // ensure the returned data is valid
        if (!array_key_exists('translations', $data['data'])) {
            throw new Exception('Unable to find translations key');
        }

        if (!is_array($data['data']['translations'])) {
            throw new Exception('Expected array for translations');
        }

        // loop over the translations and return the first one.
        // if you wanted to handle multiple translations in a single call
        // you would need to modify how this returns data
        foreach ($data['data']['translations'] as $translation) {
            return $translation['translatedText'];
        }

        // assume failure since success would've returned just above
        throw new Exception('Translation failed');
    }
}